VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8415
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   8415
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstRec 
      Height          =   3765
      Left            =   2880
      TabIndex        =   9
      Top             =   1560
      Width           =   2175
   End
   Begin VB.ListBox lstFields 
      Height          =   3765
      ItemData        =   "Form1.frx":0000
      Left            =   5160
      List            =   "Form1.frx":0002
      TabIndex        =   7
      Top             =   1560
      Width           =   3135
   End
   Begin ComctlLib.TreeView TreeView 
      Height          =   3735
      Left            =   120
      TabIndex        =   5
      Top             =   1560
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   6588
      _Version        =   327680
      HideSelection   =   0   'False
      LabelEdit       =   1
      Style           =   7
      Appearance      =   1
      Enabled         =   0   'False
   End
   Begin VB.Frame File 
      Caption         =   "File"
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8175
      Begin MSComDlg.CommonDialog OpenDialog 
         Left            =   4440
         Top             =   480
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   327680
         Filter          =   "GSO files (*.gso)|*.gso"
      End
      Begin VB.CommandButton btOpen 
         Caption         =   "Open"
         Height          =   375
         Left            =   1440
         TabIndex        =   4
         Top             =   240
         Width           =   1215
      End
      Begin VB.CommandButton btRelease 
         Caption         =   "Release"
         Height          =   375
         Left            =   6720
         TabIndex        =   3
         Top             =   240
         Width           =   1335
      End
      Begin VB.CommandButton btGetActive 
         Caption         =   "Get Active"
         Height          =   375
         Left            =   2760
         TabIndex        =   2
         Top             =   240
         Width           =   1335
      End
      Begin VB.CommandButton btNew 
         Caption         =   "New"
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1215
      End
      Begin VB.Label lbFileName 
         AutoSize        =   -1  'True
         Caption         =   "Nothing"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         Top             =   720
         Width           =   555
      End
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Nodes:"
      Height          =   195
      Left            =   120
      TabIndex        =   8
      Top             =   1320
      Width           =   510
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WinOrg As Object
Private DataFile As Object
Private ActiveTable As Object

Sub UpdateButtons()
    Dim FileOpened

    If WinOrg Is Nothing Then
        FileOpened = False
        btNew.Enabled = False
        btOpen.Enabled = False
        btGetActive.Enabled = False
    ElseIf DataFile Is Nothing Then
        FileOpened = False
        btNew.Enabled = True
        btOpen.Enabled = True
        btGetActive.Enabled = True
    Else
        FileOpened = True
        btNew.Enabled = False
        btOpen.Enabled = False
        btGetActive.Enabled = False
    End If
    
    TreeView.Enabled = FileOpened
    btRelease.Enabled = FileOpened
    
    If FileOpened Then
        lbFileName.Caption = "FileName: " + DataFile.filename
    Else
        lbFileName.Caption = "Nothing"
    End If

End Sub

Sub FillChildNodes(ATreeNodeIndex As Integer, ADataNode)
    Dim i As Integer
    Dim ANewTreeNode As Node
    
    For i = 0 To ADataNode.NodeCount - 1
       Set ANewTreeNode = TreeView.Nodes.Add(ATreeNodeIndex, tvwChild)
       ANewTreeNode.Text = ADataNode.Nodes(i).Text
       ANewTreeNode.Tag = ADataNode.Nodes(i).ID
       
       FillChildNodes ANewTreeNode.Index, ADataNode.Nodes(i)
    Next
   
    If ADataNode.ID = DataFile.Selected.ID Then
        TreeView.SelectedItem = TreeView.Nodes.Item(ATreeNodeIndex)
    End If
End Sub

Sub FillTreeView()
    Dim ANode As Node
    
    TreeView.Nodes.Clear
    Set ANode = TreeView.Nodes.Add()
    
    ANode.Text = DataFile.Root.Text
    ANode.Tag = DataFile.Root.ID
    
    FillChildNodes ANode.Index, DataFile.Root
    ANode.Expanded = True
    
End Sub

Sub FillRecords()
    Dim i, ifld_title, ARecord, AItem
    
    ifld_title = ActiveTable.TableDef.FieldByName("Title").Index
    Set ARecord = Nothing
    lstRec.Clear

    On Error GoTo Finish
    For i = 0 To ActiveTable.Count - 1
       Set AItem = ActiveTable.Items(i)
       Set ARecord = AItem.Open
       
       lstRec.AddItem (ARecord.Values(ifld_title))
    Next
    
Finish:
    If Not ARecord Is Nothing Then
        AItem.Close
    End If
End Sub

Sub FillFieldsValues()
    Dim i, ARecord, AItem, AField, S
    
    Set ARecord = Nothing
    lstFields.Clear
    
    On Error GoTo Finish
    
    If lstRec.ListIndex = -1 Then
        GoTo Finish
    End If
        
    Set AItem = ActiveTable.Items(lstRec.ListIndex)
    Set ARecord = AItem.Open
    
    For i = 0 To ActiveTable.TableDef.FieldCount - 1
        Set AField = ActiveTable.TableDef.Fields(i)
        S = AField.FieldName + " : "
        
        If AField.isBlob Then
            S = S + "BLOB"
        ElseIf ARecord.IsNull(i) Then
            S = S + "NULL"
        Else
            S = S + Format(ARecord.Values(i))
        End If
        
        lstFields.AddItem (S)
    Next

Finish:
    If Not ARecord Is Nothing Then
        AItem.Close
    End If
    
End Sub

Private Sub btNew_Click()
    Set DataFile = WinOrg.FileNew
    DataFile.Root.Text = "VB Samples"
    WinOrg.FileSelect DataFile
    UpdateButtons
End Sub

Private Sub btOpen_Click()
    OpenDialog.filename = ""
    OpenDialog.ShowOpen
    If OpenDialog.filename <> "" Then
        Set DataFile = WinOrg.FileOpen(OpenDialog.filename)
        WinOrg.FileSelect DataFile
        UpdateButtons
        FillTreeView
    End If
End Sub

Private Sub btGetActive_Click()
    If WinOrg.FileList.Count > 0 Then
        Set DataFile = WinOrg.FileList.ActiveFile
        UpdateButtons
        FillTreeView
    End If
End Sub

Private Sub btRelease_Click()
    WinOrg.FileClose DataFile
    Set DataFile = Nothing
    TreeView.Nodes.Clear
    UpdateButtons
End Sub

Private Sub Form_Load()
    Set WinOrg = CreateObject("WinOrganizer.App")
    Set DataFile = Nothing
    Set ActiveTable = Nothing
    
    UpdateButtons
   
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not ActiveTable Is Nothing Then
        ActiveTable.Owner.Close
        Set ActiveTable = Nothing
    End If
        
    If Not DataFile Is Nothing Then
        WinOrg.FileClose DataFile
        Set DataFile = Nothing
    End If
End Sub

Private Sub lstRec_Click()
    Dim i As Integer
    Dim ARec As Object
    
    FillFieldsValues
End Sub

Private Sub TreeView_NodeClick(ByVal Node As ComctlLib.Node)
    DataFile.Selected = DataFile.FindNode(Node.Tag)
    
    If Not ActiveTable Is Nothing Then
        ActiveTable.Owner.Close
        Set ActiveTable = Nothing
    End If
    
    If DataFile.TableExists(DataFile.Selected.Ext) Then
        Set ActiveTable = DataFile.Selected.Open
    Else
        Set ActiveTable = Nothing
    End If
    
    FillRecords
    FillFieldsValues
    
End Sub
