VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5820
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   4080
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.TextBox txtInfo 
      Height          =   1695
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   15
      Text            =   "Form1.frx":0000
      Top             =   3960
      Width           =   4455
   End
   Begin VB.Frame Frame4 
      Caption         =   "File tools"
      Height          =   1815
      Left            =   120
      TabIndex        =   6
      Top             =   2040
      Width           =   4455
      Begin VB.CommandButton btReload 
         Caption         =   "Reload"
         Height          =   375
         Left            =   1560
         TabIndex        =   14
         ToolTipText     =   "Reload data"
         Top             =   1320
         Width           =   1335
      End
      Begin VB.CommandButton btRefresh 
         Caption         =   "Refresh"
         Height          =   375
         Left            =   120
         TabIndex        =   13
         ToolTipText     =   "Refresh data"
         Top             =   1320
         Width           =   1335
      End
      Begin VB.CommandButton btLogoff 
         Caption         =   "Logoff"
         Height          =   375
         Left            =   3000
         TabIndex        =   12
         ToolTipText     =   "Deny access to protected documents"
         Top             =   840
         Width           =   1335
      End
      Begin VB.TextBox TxtPassword 
         Height          =   375
         Left            =   120
         TabIndex        =   11
         Top             =   840
         Width           =   1335
      End
      Begin VB.CommandButton btLogon 
         Caption         =   "Logon"
         Height          =   375
         Left            =   1560
         TabIndex        =   10
         ToolTipText     =   "Enter password"
         Top             =   840
         Width           =   1335
      End
      Begin VB.CommandButton btCompress 
         Caption         =   "Compress"
         Height          =   375
         Left            =   3000
         TabIndex        =   9
         ToolTipText     =   "Compres file"
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btSelect 
         Caption         =   "Select"
         Enabled         =   0   'False
         Height          =   375
         Left            =   120
         TabIndex        =   8
         ToolTipText     =   "Select file"
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btSave 
         Caption         =   "Save"
         Height          =   375
         Left            =   1560
         TabIndex        =   7
         ToolTipText     =   "Save file"
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Deactivating"
      Height          =   855
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   4455
      Begin VB.CommandButton btRelease 
         Caption         =   "Release"
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Activating"
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
      Begin VB.CommandButton btNew 
         Caption         =   "New"
         Height          =   375
         Left            =   120
         TabIndex        =   3
         ToolTipText     =   "Create new file"
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btOpen 
         Caption         =   "Open"
         Height          =   375
         Left            =   1560
         TabIndex        =   2
         ToolTipText     =   "Open existing file"
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton btActiveFile 
         Caption         =   "Get Active File"
         Height          =   375
         Left            =   3000
         TabIndex        =   1
         ToolTipText     =   "Get active file"
         Top             =   360
         Width           =   1335
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private WinOrg As Object
Private DataFile As Object

Sub UpdateButtons()
    Dim FileOpened

    If WinOrg Is Nothing Then
        FileOpened = False
        btNew.Enabled = False
        btOpen.Enabled = False
        btActiveFile.Enabled = False
    ElseIf DataFile Is Nothing Then
        FileOpened = False
        btNew.Enabled = True
        btOpen.Enabled = True
        btActiveFile.Enabled = True
    Else
        FileOpened = True
        btNew.Enabled = False
        btOpen.Enabled = False
        btActiveFile.Enabled = False
    End If
    
    btSelect.Enabled = FileOpened
    btRelease.Enabled = FileOpened
    btSave.Enabled = FileOpened
    btCompress.Enabled = FileOpened
    TxtPassword.Enabled = FileOpened
    btLogon.Enabled = FileOpened
    btLogoff.Enabled = FileOpened
    btRefresh.Enabled = FileOpened
    btReload.Enabled = FileOpened
    
    If FileOpened Then
        txtInfo.Text = "FileName: " + DataFile.filename
    Else
        txtInfo.Text = "Nothing"
    End If

End Sub

Private Sub Form_Load()
    Set WinOrg = CreateObject("WinOrganizer.App")
    UpdateButtons
End Sub

Private Sub btNew_Click()
    Set DataFile = WinOrg.FileNew
    DataFile.Root.Text = "VB Samples"
    UpdateButtons
End Sub

Private Sub btOpen_Click()
    CommonDialog1.filename = ""
    CommonDialog1.ShowOpen
    If CommonDialog1.filename <> "" Then
        Set DataFile = WinOrg.FileOpen(CommonDialog1.filename)
        UpdateButtons
    End If
End Sub

Private Sub btActiveFile_Click()
    If WinOrg.FileList.Count > 0 Then
        Set DataFile = WinOrg.FileList.ActiveFile
        UpdateButtons
    End If
End Sub

Private Sub btRelease_Click()
    WinOrg.FileClose DataFile
    Set DataFile = Nothing
    UpdateButtons
End Sub

Private Sub btSelect_Click()
    WinOrg.FileSelect DataFile
    UpdateButtons
End Sub

Private Sub btCompress_Click()
    DataFile.Pack True
End Sub

Private Sub btLogoff_Click()
    DataFile.Logoff
End Sub

Private Sub btLogon_Click()
    DataFile.Logon TxtPassword.Text
End Sub

Private Sub btRefresh_Click()
    DataFile.Refresh
End Sub

Private Sub btReload_Click()
    DataFile.Reload
End Sub

Private Sub btSave_Click()
    DataFile.Save
End Sub

