VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5235
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6750
   LinkTopic       =   "Form1"
   ScaleHeight     =   5235
   ScaleWidth      =   6750
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Nodes"
      Height          =   3855
      Left            =   5040
      TabIndex        =   7
      Top             =   1320
      Width           =   1575
      Begin VB.CommandButton btDelete 
         Caption         =   "Delete"
         Height          =   375
         Left            =   120
         TabIndex        =   11
         Top             =   1920
         Width           =   1335
      End
      Begin VB.CommandButton btAdd 
         Caption         =   "Add"
         Height          =   375
         Left            =   120
         TabIndex        =   10
         Top             =   1440
         Width           =   1335
      End
      Begin VB.CommandButton btMoveDn 
         Caption         =   "Move Down"
         Height          =   375
         Left            =   120
         TabIndex        =   9
         Top             =   720
         Width           =   1335
      End
      Begin VB.CommandButton btMoveUp 
         Caption         =   "Move Up"
         Height          =   375
         Left            =   120
         TabIndex        =   8
         Top             =   240
         Width           =   1335
      End
   End
   Begin ComctlLib.TreeView TreeView 
      Height          =   3855
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   4815
      _ExtentX        =   8493
      _ExtentY        =   6800
      _Version        =   327680
      HideSelection   =   0   'False
      Style           =   7
      Appearance      =   1
      Enabled         =   0   'False
      MouseIcon       =   "Form1.frx":0000
   End
   Begin VB.Frame File 
      Caption         =   "File"
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6495
      Begin MSComDlg.CommonDialog OpenDialog 
         Left            =   4440
         Top             =   480
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   327680
         Filter          =   "GSO files (*.gso)|*.gso"
      End
      Begin VB.CommandButton btOpen 
         Caption         =   "Open"
         Height          =   375
         Left            =   1440
         TabIndex        =   4
         Top             =   240
         Width           =   1215
      End
      Begin VB.CommandButton btRelease 
         Caption         =   "Release"
         Height          =   375
         Left            =   5040
         TabIndex        =   3
         Top             =   240
         Width           =   1335
      End
      Begin VB.CommandButton btGetActive 
         Caption         =   "Get Active"
         Height          =   375
         Left            =   2760
         TabIndex        =   2
         Top             =   240
         Width           =   1335
      End
      Begin VB.CommandButton btNew 
         Caption         =   "New"
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1215
      End
      Begin VB.Label lbFileName 
         AutoSize        =   -1  'True
         Caption         =   "Nothing"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         Top             =   720
         Width           =   555
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WinOrg As Object
Private DataFile As Object

Sub UpdateButtons()
    Dim FileOpened

    If WinOrg Is Nothing Then
        FileOpened = False
        btNew.Enabled = False
        btOpen.Enabled = False
        btGetActive.Enabled = False
    ElseIf DataFile Is Nothing Then
        FileOpened = False
        btNew.Enabled = True
        btOpen.Enabled = True
        btGetActive.Enabled = True
    Else
        FileOpened = True
        btNew.Enabled = False
        btOpen.Enabled = False
        btGetActive.Enabled = False
    End If
    
    TreeView.Enabled = FileOpened
    btRelease.Enabled = FileOpened
    
    If FileOpened Then
        lbFileName.Caption = "FileName: " + DataFile.filename
    Else
        lbFileName.Caption = "Nothing"
    End If

End Sub

Sub FillChildNodes(ATreeNodeIndex As Integer, ADataNode)
    Dim i As Integer
    Dim ANewTreeNode As Node
    
    For i = 0 To ADataNode.NodeCount - 1
       Set ANewTreeNode = TreeView.Nodes.Add(ATreeNodeIndex, tvwChild)
       ANewTreeNode.Text = ADataNode.Nodes(i).Text
       ANewTreeNode.Tag = ADataNode.Nodes(i).ID
       
       FillChildNodes ANewTreeNode.Index, ADataNode.Nodes(i)
    Next
   
    If ADataNode.ID = DataFile.Selected.ID Then
        TreeView.SelectedItem = TreeView.Nodes.Item(ATreeNodeIndex)
    End If
End Sub

Sub FillTreeView()
    Dim ANode As Node
    
    TreeView.Nodes.Clear
    Set ANode = TreeView.Nodes.Add()
    
    ANode.Text = DataFile.Root.Text
    ANode.Tag = DataFile.Root.ID
    
    FillChildNodes ANode.Index, DataFile.Root
    ANode.Expanded = True
    
End Sub

Private Sub btAdd_Click()
    Dim ADataNode
    
    Set ADataNode = DataFile.FindNode(TreeView.SelectedItem.Tag)
    Set ADataNode = ADataNode.AddTable
    ADataNode.Text = "Untitled"
    ADataNode.Ext = "Notes"
    DataFile.Selected = ADataNode
    
    FillTreeView
End Sub

Private Sub btDelete_Click()
    Dim ADataNode
    
    Set ADataNode = DataFile.FindNode(TreeView.SelectedItem.Tag)
    ADataNode.Delete
    
    FillTreeView
End Sub

Private Sub btMoveDn_Click()
    Dim ADataNode
    
    Set ADataNode = DataFile.FindNode(TreeView.SelectedItem.Tag)
    If ADataNode.Index < ADataNode.Parent.NodeCount - 1 Then
        ADataNode.Index = ADataNode.Index + 1
    End If
    
    FillTreeView
End Sub

Private Sub btMoveUp_Click()
    Dim ADataNode
    
    Set ADataNode = DataFile.FindNode(TreeView.SelectedItem.Tag)
    If ADataNode.Index > 0 Then
        ADataNode.Index = ADataNode.Index - 1
    End If
        
    FillTreeView
End Sub

Private Sub btNew_Click()
    Set DataFile = WinOrg.FileNew
    DataFile.Root.Text = "VB Samples"
    UpdateButtons
End Sub

Private Sub btOpen_Click()
    OpenDialog.filename = ""
    OpenDialog.ShowOpen
    If OpenDialog.filename <> "" Then
        Set DataFile = WinOrg.FileOpen(OpenDialog.filename)
        UpdateButtons
        FillTreeView
    End If
End Sub

Private Sub btGetActive_Click()
    If WinOrg.FileList.Count > 0 Then
        Set DataFile = WinOrg.FileList.ActiveFile
        UpdateButtons
        FillTreeView
    End If
End Sub

Private Sub btRelease_Click()
    WinOrg.FileClose DataFile
    Set DataFile = Nothing
    TreeView.Nodes.Clear
    UpdateButtons
End Sub

Private Sub Form_Load()
    Set WinOrg = CreateObject("WinOrganizer.App")
    UpdateButtons
   
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not DataFile Is Nothing Then
        WinOrg.FileClose DataFile
        Set DataFile = Nothing
    End If
End Sub

Private Sub TreeView_AfterLabelEdit(Cancel As Integer, NewString As String)
    Dim ADataNode
    Set ADataNode = DataFile.FindNode(TreeView.SelectedItem.Tag)
    ADataNode.Text = NewString
End Sub

Private Sub TreeView_NodeClick(ByVal Node As ComctlLib.Node)
    DataFile.Selected = DataFile.FindNode(Node.Tag)
End Sub
